%function scores = MOcluster_fitness(x,matrix1,matrix2)
function scores = MOcluster_fitness(x,M)
%function scores = cluster_fitness(x)
%CLUSTER_FITNESS  Custom fitness function for cluster. 
%   SCORES = CLUSTER_FITNESS(X,submatrix) Calculate the fitness 
%   of an individual. The fitness is the sum of the scores of each cluster
%   created.


%scores = zeros(size(x,1),1);
x_fitness=x;
numlivelli=size(M,3);%Annalisa
scores = zeros(size(x,1),numlivelli);%Annalisa


for numchrom = 1:size(x,1)
  
    CC=decodenew(x(numchrom,:));
    
    for i=1:numlivelli % Annalisa
        scores(numchrom,i)=-computeGain(CC,M(:,:,i)); %Annalisa
        %scores(numchrom,i)=computeGain2(CC,M(:,:,i)); %Annalisa
    end

   %scores(numchrom,1)= -computeGain(CC,matrix1);
   
   %scores(numchrom,2)= -computeGain(CC,matrix2);
    
end


function mod = computeGain(CC,M)
         mod=0;
         numEdges=sum(sum(M(:,:)));
        
         for k=1:size(CC,2)
                                             %che formano la componente corrente
            listnodes=CC{k};   
    %ls is the number of edges joining nodes of the community k
    %ds is the sum of the degrees of the nodes belonging to the community k
            ls=sum(sum(M(listnodes,listnodes)));
            ds=sum(sum(M(listnodes,:)));
            if ((ds >0)& size(listnodes,2)>2)
              mod = mod + (ls/numEdges - (ds/numEdges)^2);
            end
            
         end
end
function score = computeGain2(CC,M)
         score=double(0);
         
         %numEdges=sum(sum(M(:,:)));
         %if(size(CC,2)>1)
         for k=1:size(CC,2)
             k
            listnodes=CC{k}
            if (size(listnodes,2)>2)              
              score=score+conductance_Lesko(listnodes,M)
            end 
         end
         %end
         score
end


function condc=conductance_Lesko(order, A)
B = A(order, order)
B_lower = tril(B)
B_sums = full(sum(B, 2))
B_lower_sums = sum(B_lower, 2)
volumes = cumsum(B_sums)
num_cut = cumsum(B_sums - 2 * B_lower_sums)
total_vol = full(sum(sum(A)))
volumes_other = total_vol * ones(length(order), 1) - volumes
vols = min(volumes, volumes_other)
for i=1:size(num_cut,1)
    num_cut(i,1)
if (min(vols)==0 || num_cut(i,1)==0)
    condc=1;
end
end
if(condc~=1)
scores_ = num_cut ./ vols
scores_ = full(scores_(1:(end-1)))

[condc, min_ind] = min(scores_);
end
end
end
